<?php
/**
 * APP 客户端
 * Created by PhpStorm.
 * User: guanxl
 * Date: 2018/5/24
 * Time: 15:09
 */

namespace App\Libs;


class AppClient
{
    const BROWSER_TYPE_WECHAT = 'wechat';
    const BROWSER_TYPE_WESUITAPP = 'wesuit_app';
    const BROWSER_TYPE_CMB_MOBILE_OA = 'cmb_mobile_oa';
    const BROWSER_TYPE_PINGAN_ZHINIAO = 'pingan_zhiniao';
    const BROWSER_TYPE_YUNZHIJIA = 'yunzhijia';
    const BROWSER_TYPE_DINGTALK = 'dingtalk';
    const BROWSER_TYPE_KARA = 'kara';
    const BROWSER_TYPE_NOT_WX = '';

    /**
     * 得到APP client的类型
     * @return string
     */
    public static function browserType() {
        if(strpos($_SERVER['HTTP_USER_AGENT'], 'wxwork') !== false) {
            return self::BROWSER_TYPE_WESUITAPP;
        } elseif(strpos($_SERVER['HTTP_USER_AGENT'], 'CMBMobileOA') !== false) {
            return self::BROWSER_TYPE_CMB_MOBILE_OA;
        } elseif(strpos($_SERVER['HTTP_USER_AGENT'], 'PinganZhiniao') !== false) {
            return self::BROWSER_TYPE_PINGAN_ZHINIAO;
        } elseif(strpos($_SERVER['HTTP_USER_AGENT'], 'MicroMessenger') !== false) {
            return self::BROWSER_TYPE_WECHAT;
        } elseif(strpos($_SERVER['HTTP_USER_AGENT'], 'Qing') !== false) {
            return self::BROWSER_TYPE_YUNZHIJIA;
        } elseif(strpos($_SERVER['HTTP_USER_AGENT'], 'DingTalk') !== false) {
            return self::BROWSER_TYPE_DINGTALK;
        } elseif(strpos($_SERVER['HTTP_USER_AGENT'], 'kara') !== false) {
            return self::BROWSER_TYPE_KARA;
        } else {
            return self::BROWSER_TYPE_NOT_WX;
        }
    }

    /**
     * 是否微信访问
     * @return bool
     */
    public static function isWxBrowser() {
        return (strpos($_SERVER['HTTP_USER_AGENT'], 'MicroMessenger') !== false) ||
            (strpos($_SERVER['HTTP_USER_AGENT'], 'wxwork') !== false);
    }

    // 查看是否为手机端的方法
    //判断是手机登录还是电脑登录
    public static function isMobile() {
        // 如果有HTTP_X_WAP_PROFILE则一定是移动设备
        if (isset ($_SERVER['HTTP_X_WAP_PROFILE']))
            return true;

        //此条摘自TPM智能切换模板引擎，适合TPM开发
        if(isset ($_SERVER['HTTP_CLIENT']) &&'PhoneClient'==$_SERVER['HTTP_CLIENT'])
            return true;
        //如果via信息含有wap则一定是移动设备,部分服务商会屏蔽该信息
        if (isset ($_SERVER['HTTP_VIA']))
            //找不到为flase,否则为true
            return stristr($_SERVER['HTTP_VIA'], 'wap') ? true : false;
        //判断手机发送的客户端标志,兼容性有待提高
        if (isset ($_SERVER['HTTP_USER_AGENT'])) {
            $clientkeywords = array(
                'nokia','sony','ericsson','mot','samsung','htc','sgh','lg','sharp','sie-','philips','panasonic','alcatel','lenovo','iphone','ipod','blackberry','meizu','android','netfront','symbian','ucweb','windowsce','palm','operamini','operamobi','openwave','nexusone','cldc','midp','wap','mobile'
            );
            //从HTTP_USER_AGENT中查找手机浏览器的关键字
            if (preg_match("/(" . implode('|', $clientkeywords) . ")/i", strtolower($_SERVER['HTTP_USER_AGENT']))) {
                return true;
            }
        }
        //协议法，因为有可能不准确，放到最后判断
        if (isset ($_SERVER['HTTP_ACCEPT'])) {
            // 如果只支持wml并且不支持html那一定是移动设备
            // 如果支持wml和html但是wml在html之前则是移动设备
            if ((strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html')))) {
                return true;
            }
        }
        return false;
    }
}